"use strict";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var dateUtil_1 = require("../utils/dateUtil");

var miscUtil_1 = require("../utils/miscUtil");

function useCellClassName(_ref) {
  var cellPrefixCls = _ref.cellPrefixCls,
      generateConfig = _ref.generateConfig,
      rangedValue = _ref.rangedValue,
      hoverRangedValue = _ref.hoverRangedValue,
      isInView = _ref.isInView,
      isSameCell = _ref.isSameCell,
      offsetCell = _ref.offsetCell,
      today = _ref.today,
      value = _ref.value;

  function getClassName(currentDate) {
    var _ref2;

    var prevDate = offsetCell(currentDate, -1);
    var nextDate = offsetCell(currentDate, 1);
    var isRangeHovered = dateUtil_1.isInRange(generateConfig, miscUtil_1.getValue(hoverRangedValue, 0), miscUtil_1.getValue(hoverRangedValue, 1), currentDate);

    function isRangeStart(date) {
      return isSameCell(miscUtil_1.getValue(rangedValue, 0), date);
    }

    function isRangeEnd(date) {
      return isSameCell(miscUtil_1.getValue(rangedValue, 1), date);
    }

    var isHoverStart = isSameCell(miscUtil_1.getValue(hoverRangedValue, 0), currentDate);
    var isHoverEnd = isSameCell(miscUtil_1.getValue(hoverRangedValue, 1), currentDate);
    return _ref2 = {}, _defineProperty(_ref2, "".concat(cellPrefixCls, "-in-view"), isInView(currentDate)), _defineProperty(_ref2, "".concat(cellPrefixCls, "-in-range"), dateUtil_1.isInRange(generateConfig, miscUtil_1.getValue(rangedValue, 0), miscUtil_1.getValue(rangedValue, 1), currentDate)), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-start"), isRangeStart(currentDate)), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-end"), isRangeEnd(currentDate)), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-hover"), isRangeHovered), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-hover-start"), isHoverStart), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-hover-end"), isHoverEnd), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-hover-edge-start"), (isRangeHovered || isHoverEnd) && (!isInView(prevDate) || isRangeEnd(prevDate))), _defineProperty(_ref2, "".concat(cellPrefixCls, "-range-hover-edge-end"), (isRangeHovered || isHoverStart) && (!isInView(nextDate) || isRangeStart(nextDate))), _defineProperty(_ref2, "".concat(cellPrefixCls, "-today"), isSameCell(today, currentDate)), _defineProperty(_ref2, "".concat(cellPrefixCls, "-selected"), isSameCell(value, currentDate)), _ref2;
  }

  return getClassName;
}

exports.default = useCellClassName;