"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var miscUtil_1 = require("../utils/miscUtil");

var dateUtil_1 = require("../utils/dateUtil");

function useRangeDisabled(_ref) {
  var selectedValue = _ref.selectedValue,
      disabledDate = _ref.disabledDate,
      disabled = _ref.disabled,
      generateConfig = _ref.generateConfig;
  var startDate = miscUtil_1.getValue(selectedValue, 0);
  var endDate = miscUtil_1.getValue(selectedValue, 1);

  function disabledStartDate(date) {
    if (disabledDate && disabledDate(date)) {
      return true;
    }

    if (disabled[1] && endDate) {
      return !dateUtil_1.isSameDate(generateConfig, date, endDate) && generateConfig.isAfter(date, endDate);
    }

    return false;
  }

  function disableEndDate(date) {
    if (disabledDate && disabledDate(date)) {
      return true;
    }

    if (startDate) {
      return !dateUtil_1.isSameDate(generateConfig, date, startDate) && generateConfig.isAfter(startDate, date);
    }

    return false;
  }

  return [disabledStartDate, disableEndDate];
}

exports.default = useRangeDisabled;